Last Comment Bug 291099 - Using keyboard to navigate through context menus of menu items (e.g. bookmarks) skips every other item
: Using keyboard to navigate through context menus of menu items (e.g. bookmark...
Status: VERIFIED FIXED
[no l10n impact]
: fixed1.8, regression, testcase
Product: Core
Classification: Components
Component: XUL (show other bugs)
: Trunk
: x86 Windows XP
: -- normal (vote)
: ---
Assigned To: neil@parkwaycc.co.uk
:
: Neil Deakin
Mentors:
: 304603 311259 (view as bug list)
Depends on:
Blocks: 167145
  Show dependency treegraph
 
Reported: 2005-04-20 00:01 PDT by Robert Strong [:rstrong] (use needinfo to contact me)
Modified: 2008-07-31 03:17 PDT (History)
12 users (show)
benjamin: blocking1.8b3-
asa: blocking1.8b5-
mscott: blocking1.8rc1+
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments
testcase (1.13 KB, application/vnd.mozilla.xul+xml)
2005-04-20 18:12 PDT, Robert Strong [:rstrong] (use needinfo to contact me)
no flags Details
Ignore key presses that have already been dealt with. There can be more than one listener on the same node. (1.26 KB, patch)
2005-08-04 07:19 PDT, Aaron Leventhal
no flags Details | Diff | Splinter Review
Don't attach multiple listeners (1.95 KB, patch)
2005-08-06 16:48 PDT, neil@parkwaycc.co.uk
aaronlev: review+
dbaron: superreview+
asa: approval1.8rc1+
Details | Diff | Splinter Review

Description Robert Strong [:rstrong] (use needinfo to contact me) 2005-04-20 00:01:33 PDT
User-Agent:       Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8b2) Gecko/20050418 Firefox/1.0+
Build Identifier: Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8b2) Gecko/20050418 Firefox/1.0+

When using the keyboard to select bookmark context menu menuitems some menuitems
are often skipped. The closest bug to this I could find is bug 266076 but that
deals with accesskeys.

Reproducible: Always

Steps to Reproduce:
1. Click Bookmarks and context menu click a bookmark
2. Use the arrow keys to select menuitems

Actual Results:  
Some enabled menuitems are skipped

Expected Results:  
Each enabled menuitem is selected in turn

This bug appears for all bookmarks and bookmark folder in the Bookmarks menu. It
appears that if the context menu is brought up from the top of the Bookmarks
Toolbar for a bookmark or bookmark folder that it is possible to select each
enabled menuitem in turn using the arrow keys on the keyboard. If the bookmark
or bookmark folder is inside of another bookmark folder in the Bookmarks Toolbar
that this bug is exhibited.
Comment 1 Peter van der Woude [:Peter6] 2005-04-20 08:51:09 PDT
Mozilla/5.0 (Windows; U; Windows NT 5.0; en-US; rv:1.8b2) Gecko/20050419
Firefox/1.0+

Confirmed.

the Items are picked seemingly at random
very much depends on where the mousepointer is located
Comment 2 Phil Ringnalda (:philor) 2005-04-20 15:32:15 PDT
Looks to have regressed somewhere between 20050117 and 20050127. And at least
what I'm seeing isn't random, it's just every other menu item gets skipped.
Comment 3 Robert Strong [:rstrong] (use needinfo to contact me) 2005-04-20 17:54:14 PDT
I noticed it wasn't random as well just after filing. It seems as if the
keypress event is running twice for popups that are a contentmenu of a popup.
Comment 4 Robert Strong [:rstrong] (use needinfo to contact me) 2005-04-20 18:12:34 PDT
Created attachment 181370 [details]
testcase
Comment 5 Robert Strong [:rstrong] (use needinfo to contact me) 2005-04-20 18:19:33 PDT
This does not appear to be bookmarks specific though it does affect bookmarks.
Changing the summary, product, and component accordingly though I suspect the
category may still be incorrect.
Comment 6 Robert Strong [:rstrong] (use needinfo to contact me) 2005-04-20 19:10:45 PDT
Reassigning to nobody@mozilla.org since this is not bookmarks specific to get it
off of Vladimir's plate.
Comment 7 Phil Ringnalda (:philor) 2005-04-20 19:29:05 PDT
Aaron, could this be a regression from your bug 282438? The window is
2005-02-17-07 to 2005-02-18-07, and even though I don't know what I'm talking
about, yours looks the most likely.
Comment 8 Boris Zbarsky [:bz] (still a bit busy) 2005-05-17 10:25:56 PDT
The regression range in comment 7 is off by a month (compare comment 2).  I see
the bug in a 2005-01-19-08 build but not a 2005-01-18-07 build.

So bug 282438 is definitely not it.

Bug 167145, on the other hand, is quite a likely culprit, since it messed around
with key events...
Comment 9 Aaron Slunt 2005-08-03 11:12:34 PDT
Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8b4) Gecko/20050802
Firefox/1.0+ ID:2005080207

For me, the navigation moves in the opposite direction of the key i'm pressing.
i.e. I press up and it moves down.
Comment 10 Robert Strong [:rstrong] (use needinfo to contact me) 2005-08-03 11:22:06 PDT
Aaron - it appears that way visually because it is skipping an item.
Comment 11 Aaron Leventhal 2005-08-04 07:19:12 PDT
Created attachment 191588 [details] [diff] [review]
Ignore key presses that have already been dealt with. There can be more than one listener on the same node.
Comment 12 Aaron Leventhal 2005-08-04 07:56:54 PDT
Spin off bug 303404 is a crash I found while debugging this.
Comment 13 neil@parkwaycc.co.uk 2005-08-06 16:48:46 PDT
Created attachment 191845 [details] [diff] [review]
Don't attach multiple listeners
Comment 14 Aaron Leventhal 2005-08-14 14:42:33 PDT
*** Bug 304603 has been marked as a duplicate of this bug. ***
Comment 15 Aaron Leventhal 2005-08-19 10:11:55 PDT
Neil's got a patch
Comment 16 neil@parkwaycc.co.uk 2005-09-29 06:19:16 PDT
Fix checked in to the trunk.
Comment 17 Omer Kehri 2005-10-05 14:51:55 PDT
*** Bug 311259 has been marked as a duplicate of this bug. ***
Comment 18 Asa Dotzler [:asa] 2005-10-10 17:36:08 PDT
Comment on attachment 191845 [details] [diff] [review]
Don't attach multiple listeners

I'm nervous about this change. We can't afford any regressions this late in the
game. What kind of testing has been done here and what kind of risk does this
patch pose?
Comment 19 Asa Dotzler [:asa] 2005-10-11 16:14:52 PDT
neil, aaron, qa, have we verified that this doesn't break anything?
Comment 20 Marcia Knous [:marcia - use ni] 2005-10-11 16:40:46 PDT
I will check this on Windows XP, but using today's Mac trunk build (Mozilla/5.0
(Macintosh; U; PPC Mac OS X Mach-O; en-US; rv:1.9a1) Gecko/20051011
Firefox/1.6a1), the test case doesn't work. Using today's Mac Branch build, the
test case does work.
Comment 21 Marcia Knous [:marcia - use ni] 2005-10-11 16:55:01 PDT
Just to clarify, when I mean the test case works, you can use the arrow keys to
move up and down without skipping.

(In reply to comment #20)
> I will check this on Windows XP, but using today's Mac trunk build (Mozilla/5.0
> (Macintosh; U; PPC Mac OS X Mach-O; en-US; rv:1.9a1) Gecko/20051011
> Firefox/1.6a1), the test case doesn't work. Using today's Mac Branch build, the
> test case does work.
Comment 22 Marcia Knous [:marcia - use ni] 2005-10-11 17:02:24 PDT
This looks ok using today's Windows Trunk build (Mozilla/5.0 (Windows; U;
Windows NT 5.1; en-US; rv:1.9a1) Gecko/20051011 Firefox/1.6a1). If I run the
test case, I can arrow through the choices with no problem. I also did some
context clicking on bookmarks and didn't see any problems.
Comment 23 Scott MacGregor 2005-10-12 11:23:45 PDT
plussing since we decide to take this patch.
Comment 24 Scott MacGregor 2005-10-13 17:38:58 PDT
Neil, can you get this checked into the branch soon? If not, let us know and we
can find someone who can land it (maybe me :)).

Comment 25 neil@parkwaycc.co.uk 2005-10-14 02:37:32 PDT
Sorry, I overlooked the a=asa.

Note You need to log in before you can comment on or make changes to this bug.